package main;

import java.util.HashMap;
import java.util.HashSet;
import operand.IOperand;
import operator.IOperator;

/**
 * \interface
 */
public interface ISimplify {

	/**
	 * rule simplification
	 */
	public String ruleSimplify(String target);

	/**
	 * equivalent simplification
	 */
	public String equivalanceSimplify(String target);

	/**
	 * get node value
	 */
	public double getFunctionValue(MyTreeNode node);

	/**
	 * rule and equivalent simplification
	 */
	public String ruleAndEquivalanceSimplify(String target);

	/**
	 * zero check
	 */
	public boolean isZero(double value);

	/**
	 * equal check
	 */
	public boolean isSameValue(double value1, double value2);

	public HashMap<String, double[]> getTestPoint();

	public HashMap<String, IOperator> getOperator();

	public HashMap<String, IOperand> getOperand();

	public HashSet<String> getEquivalanceCheckNodes();

	public NDecimialNumberArray getNArray();

	public void setTestPoint(HashMap<String, double[]> testPoints);

	public void setOperand(HashMap<String, IOperand> operands);

	public void setOperator(HashMap<String, IOperator> operator);

	public void setEquivalanceCheckNodes(HashSet<String> equivalanceCheckNodes);

	public void setNArray(NDecimialNumberArray nArray);

}
