package main;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Stack;

public class MyTreeUtil {

	private static ISimplify simplify_;

	public MyTreeUtil() {
	}

	/**
	 * tree->RPN
	 * 
	 * @param node
	 * @return
	 */
	public static String TreeToPostOrder(MyTreeNode node) {

		StringBuffer s = new StringBuffer();
		Enumeration em = node.postorderEnumeration();

		while (em.hasMoreElements()) {
			s.append(em.nextElement().toString() + " ");
		}

		return new String(s.substring(0, s.length() - 1));
	}

	/**
	 * RPN->tree
	 * 
	 * @param str
	 * @return
	 */
	public static MyTreeNode postOrderToTree(String str) {

		String[] s = str.split(" ");
		Stack<MyTreeNode> stack = new Stack<MyTreeNode>();

		for (int i = 0; i < s.length; i++) {

			MyTreeNode node = new MyTreeNode(s[i]);

			if (simplify_.getOperator().containsKey(s[i])) {

				ArrayList<MyTreeNode> list = new ArrayList<MyTreeNode>();

				for (int j = 0; j < simplify_.getOperator().get(s[i])
						.numOfOperand(); j++) {
					list.add(stack.pop());
				}
				for (int j = 0; j < list.size(); j++) {
					node.add(list.get(list.size() - 1 - j));
				}
				stack.push(node);
			} else if (simplify_.getOperand().containsKey(s[i])) {
				stack.push(node);
			} else {
				System.out.println("Operand|Operator " + s[i] + " is wrong.");
				System.exit(-1);
			}
		}
		MyTreeNode result = stack.pop();
		if (!stack.isEmpty()) {
			System.out.println("RPN \"" + str + "\"is wrong.");
			System.exit(-1);
		}
		return result;
	}

	/**
	 * sort ondes
	 * 
	 * @param node
	 * @return
	 */
	public static String reorderTree(String node) {

		MyTreeNode newNode = MyTreeUtil.postOrderToTree(node);
		Enumeration en = newNode.breadthFirstEnumeration();

		while (en.hasMoreElements()) {
			MyTreeNode tempNode = (MyTreeNode) en.nextElement();

			if (tempNode.isLeaf()) {
				continue;
			}
			boolean isChangeable = simplify_.getOperator().get(
					tempNode.toString()).isChangeable();
			if (!isChangeable) {
				continue;
			}
			Enumeration children = tempNode.children();
			ArrayList<MyTreeNode> operand = new ArrayList<MyTreeNode>();
			ArrayList<MyTreeNode> operator = new ArrayList<MyTreeNode>();
			while (children.hasMoreElements()) {
				MyTreeNode child = (MyTreeNode) children.nextElement();
				if (child.isLeaf()) {
					if (operand.isEmpty()) {
						operand.add(child);
					} else {
						boolean frag = false;
						int size = operand.size();
						for (int i = 0; i < size; i++) {
							MyTreeNode temp = operand.get(i);
							if (temp.toString().compareTo(child.toString()) > 0) {
								operand.add(i, child);
								frag = true;
							}
							if (!frag) {
								operand.add(child);
							}
						}
					}
				} else {
					if (operator.isEmpty()) {
						operator.add(child);
					} else {
						boolean frag = false;
						int size = operator.size();
						for (int i = 0; i < size; i++) {
							MyTreeNode temp = operator.get(i);
							if (temp.toString().compareTo(child.toString()) > 0) {
								operator.add(i, child);
								frag = true;
							}
							if (!frag) {
								operator.add(child);
							}
						}
					}
				}
			}

			tempNode.removeAllChildren();
			int operatorCount = operator.size();
			int operandCount = operand.size();
			for (int i = 0; i < operatorCount; i++) {
				tempNode.add(operator.get(i));
			}
			for (int i = 0; i < operandCount; i++) {
				tempNode.add(operand.get(i));
			}
		}

		return MyTreeUtil.TreeToPostOrder(newNode);
	}

	public static void setSimplify(ISimplify simplify) {
		simplify_ = simplify;
	}

	public static ISimplify getSimplify() {
		return simplify_;
	}
}
