package main;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class SimplifyMain {

	public static void main(String[] args) {

		MyFileReader fileReader = new MyFileReader();
		ISimplify simplify = fileReader.getSimplify();
		MyTreeUtil.setSimplify(simplify);

		Pattern pattern = Pattern.compile("^\\s*generation");
		for (int i = 0; i < args.length; i++) {
			try {
				BufferedReader br = new BufferedReader(new FileReader(args[i]));
				PrintWriter pw = new PrintWriter(new BufferedWriter(
						new FileWriter("simple_" + args[i])));

				while (true) {
					String line = br.readLine();
					if (!fileReader.isSkip(line)) {
						simplify.setTestPoint(fileReader.getTestPoint(line,
								simplify.getOperand()));
						break;
					}
				}

				System.out.println("start " + args[i]);
				while (br.ready()) {
					String line = br.readLine();

					if (!fileReader.isSkip(line)) {

						Matcher matcher = pattern.matcher(line);
						if (matcher.find()) {
							System.out.println(line);
							pw.println(line);
							continue;
						}

						String result = simplify
								.ruleAndEquivalanceSimplify(line);
						result = MyTreeUtil.reorderTree(result);
						pw.println(result);
					}
				}
				br.close();
				pw.close();

			} catch (Exception e) {
				e.printStackTrace();
			}
			System.out.println("end " + args[i]);
		}
	}
}
