package operator;

import simplifyRule.ISimplifyRule;
import function.IFunction;

/**
 * operator interface
 */
public interface IOperator {

	/**
	 * symbol
	 */
	public String getSymbol();

	/**
	 * function class
	 */
	public IFunction getFunction();

	/**
	 * number of operand
	 */
	public int numOfOperand();

	/**
	 * class of rule simplification
	 */
	public ISimplifyRule getSimplifyRule();

	/**
	 * commutative info
	 */
	public boolean isChangeable();

	/**
	 * 
	 * @param symbol
	 * @param function
	 * @param numOfOperand
	 * @param zeroElement
	 * @param identityElement
	 * @param simpilfyRule
	 */
	public void setAllParams(String symbol, IFunction function,
			int numOfOperand, ISimplifyRule simplifyRule, boolean isChangeable);
}
