package test;

import main.ISimplify;
import main.MyFileReader;
import main.MyTreeNode;
import main.MyTreeUtil;
import simplifyRule.AddRule;
import junit.framework.TestCase;

public class AddRuleTest extends TestCase {

	AddRule rule_ = new AddRule();

	MyFileReader reader_ = new MyFileReader();

	ISimplify simplify_ = reader_.getSimplify();

	public void testSimplify() {
		MyTreeUtil.setSimplify(simplify_);

		MyTreeNode element = MyTreeUtil.postOrderToTree("X S 0 + 1 -");
		MyTreeNode node = (MyTreeNode) element.getChildAt(0);
		rule_.simplify(node);
		String result = MyTreeUtil.TreeToPostOrder(element);
		assertEquals("X S 1 -", result);

		element = MyTreeUtil.postOrderToTree("1 0 X 1 - + /");
		node = (MyTreeNode) element.getChildAt(1);
		rule_.simplify(node);
		result = MyTreeUtil.TreeToPostOrder(element);
		assertEquals("1 X 1 - /", result);

		element = MyTreeUtil.postOrderToTree("1 0 X X + 0 1 - * + /");
		node = (MyTreeNode) element.getChildAt(1);
		rule_.simplify(node);
		result = MyTreeUtil.TreeToPostOrder(element);
		assertEquals("1 X X + 0 1 - * /", result);
	}
}
