package test;

import java.util.ArrayList;
import main.NDecimialNumber;
import main.NDecimialNumberArray;
import junit.framework.TestCase;

public class NDecimialNumberArrayTest extends TestCase {

	NDecimialNumberArray nArray_ = new NDecimialNumberArray();

	public void testNext() {
		getArray();

		ArrayList<NDecimialNumber> array = nArray_.getArray();
		boolean frag = false;
		int i = 0;

		do {
			assertEquals(i % 2, array.get(0).getNum());
			assertEquals((i / 2) % 5, array.get(1).getNum());
			assertEquals((i / (2 * 5)) % 4, array.get(2).getNum());
			assertTrue(!frag);
			frag = nArray_.next();
			i++;
		} while (!frag);
		assertTrue(frag);
		assertEquals(40, i);

	}

	public void testReset() {
		getArray();

		for (int i = 0; i < 4; i++) {
			nArray_.next();
		}
		ArrayList<NDecimialNumber> array = nArray_.getArray();
		assertEquals(0, array.get(0).getNum());
		assertEquals(2, array.get(1).getNum());
		assertEquals(0, array.get(2).getNum());

		nArray_.reset();
		for (int i = 0; i < array.size(); i++) {
			assertEquals(0, array.get(i).getNum());
			if (i > 3) {
				fail();
			}
		}

	}

	public void testGetNumOfSymbol() {
		getArray();

		for (int i = 0; i < 15; i++) {
			nArray_.next();
		}
		int x = nArray_.getNumOfSymbol("X");
		int y = nArray_.getNumOfSymbol("Y");
		int z = nArray_.getNumOfSymbol("Z");

		assertEquals(1, x);
		assertEquals(2, y);
		assertEquals(1, z);
	}

	private void getArray() {
		ArrayList<NDecimialNumber> points = new ArrayList<NDecimialNumber>();
		NDecimialNumber point1 = new NDecimialNumber(2, "X");
		NDecimialNumber point2 = new NDecimialNumber(5, "Y");
		NDecimialNumber point3 = new NDecimialNumber(4, "Z");
		points.add(point1);
		points.add(point2);
		points.add(point3);
		nArray_.setArray(points);
	}

}
